unit cairomain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Printers, PrintersDlgs,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    PrintBtn: TButton;
    PrintDialog1: TPrintDialog;
    procedure PrintBtnClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure prn(Printer: TPrinter);
const
  LEFTMARGIN = 100;
  HEADLINE = 'I Printed My Very First Text On ';
  FILENAME = '/tmp/bitmap.bmp';
var
  YPos, LineHeight, VerticalMargin, i: Integer;
  SuccessString: String;
  MBitmap: TBitmap;
  MRect: TRect;
  MCanvas: TCanvas;
begin
  MBitmap := nil;
  try
    MBitmap := TBitmap.Create;
    if FileExistsUTF8(FILENAME) and false then begin
      MBitmap.LoadFromFile(FILENAME);
    end else begin
      MBitmap.SetSize(640, 248);
      MCanvas := MBitmap.Canvas;
      MCanvas.Brush.Color := TColor($FF8080);
      MCanvas.FillRect(0, 0, MBitmap.Width, MBitmap.Height);
      MCanvas.Pen.Color := TColor($00FF00);
      MCanvas.MoveTo(100, 100);
      MCanvas.LineTo(100, 200);
      MCanvas.LineTo(200, 100);
      MCanvas.LineTo(100, 100);
    end;
    // 236-2236 x 506-1281
    MRect.Left := 236;
    MRect.Right := 2236;
    MRect.Top := 506;
    MRect.Bottom := 1281;
    for i := 0 to 1 do begin
      if i > 0 then Printer.NewPage;

      MCanvas := Printer.Canvas;
      MCanvas.StretchDraw(MRect, MBitmap);
      MCanvas.Font.Name := 'Courier New';
      MCanvas.Font.Size := 10;
      //MCanvas.Font.Color := clBlack;
      LineHeight := Round(1.2 * Abs(MCanvas.TextHeight('I')));
      VerticalMargin := 4 * LineHeight;
      // There we go
      YPos := VerticalMargin;
      SuccessString := HEADLINE + DateTimeToStr(Now);
      MCanvas.TextOut(LEFTMARGIN, YPos, SuccessString);
      MCanvas.Rectangle(300, 300, 550, 550);

      MCanvas.Pen.Color := TColor($0000FF);
      MCanvas.Line(111, 111, 111, 222);
      MCanvas.Line(111, 111, 222, 111);

      MCanvas.Pen.Color := TColor($FF0000);
      MRect := Rect(0, 0, 600, 100000);
      MCanvas.TextRect(MRect, 444, 444, 'strcprstskrzkrk');
    end;
  finally
    FreeAndNil(MBitmap);
  end;
end;

procedure TForm1.PrintBtnClick(Sender: TObject);
const
  LEFTMARGIN = 100;
var
  YPos, LineHeight, VerticalMargin, i: Integer;
  SuccessString: String;
begin
  if not printdialog1.execute then exit;
  Printer.BeginDoc;
    prn(Printer);
  //
  //MCanvas.Font.Name := 'Courier New';
  //MCanvas.Font.Size := 10;
  ////MCanvas.Font.Color := clBlack;
  //LineHeight := Round(1.2 * Abs(MCanvas.TextHeight('I')));
  //VerticalMargin := 4 * LineHeight;
  //// There we go
  //YPos := VerticalMargin;
  //SuccessString := 'Hi! '  + DateTimeToStr(Now);
  //MCanvas.TextOut(LEFTMARGIN, YPos, SuccessString);
  //
  //Printer.NewPage;
  //Printer.NewPage;
  Printer.EndDoc;
end;

end.

